## Sid Meier's Civilization 4
## Copyright Firaxis Games 2005

from CvPythonExtensions import *
import CvUtil
import CvEventManager
import PyHelpers
import CvAdvisorUtils
import sys
import CustomFunctions
	
# globals
gc = CyGlobalContext()
PyPlayer = PyHelpers.PyPlayer
cf = CustomFunctions.CustomFunctions()


###################################################
class CvCustomEventManager(CvEventManager.CvEventManager):
	def __init__(self):
		# initialize base class
		self.parent = CvEventManager.CvEventManager
		self.parent.__init__(self)
#                self.Events[7500] = ('DestroyBuildingPopup', cf.DestroyBuildingApply , cf.DestroyBuildingBegin)

        def onCityDoTurn(self, argsList):
                self.parent.onCityDoTurn(self, argsList)                
		'City Production'
		pCity = argsList[0]
		iPlayer = argsList[1]
		
#                cf.updateCityProcess(pCity)

		CvUtil.pyPrint("%s has performed its turn." %(pCity.getName(),))

	def onCityBuilt(self, argsList):
                self.parent.onCityBuilt(self, argsList)
		'City Built'
		pCity = argsList[0]

#                cf.initCityProcess(pCity)

        def onCityRazed(self, argsList):
                self.parent.onCityRazed(self, argsList)
		'City Razed'
		pCity, iPlayer = argsList
                pCityID = pCity.getID()
		
#                del cf.CityInfrastructure[pCityID]

	def onUnitKilled(self, argsList):
		'Unit Killed'
		self.parent.onUnitKilled(self, argsList)
		unit, iAttacker = argsList
		player = PyPlayer(unit.getOwner())
		attacker = PyPlayer(iAttacker)

                if unit.isHasPromotion(gc.getInfoTypeForString("PROMOTION_LEADER")):
                    cf.saveGreatGeneral(unit, player, attacker)

	def onBeginPlayerTurn(self, argsList):
		'Called at the beginning of a players turn'
		iGameTurn, iPlayer = argsList

                pPlayer = gc.getPlayer(iPlayer)
                pPlayer.changeGreatPeopleThresholdModifier(- (pPlayer.getGreatPeopleThresholdModifier() + 100) / 100);

		cf.resetGeneralDeath(iPlayer)

	def onGreatPersonBorn(self, argsList):
                self.parent.onGreatPersonBorn(self, argsList)
                pUnit, iPlayer, pCity = argsList
		pPlayer = PyPlayer(iPlayer)

		for nPlayer in range(gc.getMAX_PLAYERS()):
			player = gc.getPlayer(nPlayer)
			if player.isAlive() and not player.getTeam() == gc.getTeam(iPlayer):
                                player.changeGreatPeopleThresholdModifier(gc.getDefineINT("GREAT_PEOPLE_THRESHOLD_INCREASE_GLOBAL"));
